
#include <vcg/simplex/vertexplus/base.h>

#include <vcg/simplex/faceplus/base.h>
#include <vcg/simplex/face/pos.h>

#include <vcg/complex/trimesh/base.h>


//#include <wrap/gl/trimesh.h>

class CEdge;    // dummy prototype never used
class CFace;

class CVertex : public vcg::VertexSimp2< CVertex, CEdge, CFace, vcg::vert::Coord3f, vcg::vert::Normal3f >{
public:
  int nriver; // how many tris of river adjacent
};

class CFace   : public vcg::FaceSimp2<   CVertex, CEdge, CFace, vcg::face::VertexRef > {
public:
  int zoneid;
  float shade;
  void ComputeShade();
  bool GetBariCoords(vcg::Point3f p, float &a, float &b, float &c ) const;
  vcg::Point3f GetN() const;

};

class Map   : public vcg::tri::TriMesh< std::vector<CVertex>, std::vector<CFace> > {
  public:
  bool Load(char* filename);
  bool Save(char* filename);
  
  bool ReloadMapColors();
  bool SaveMapColors();
  
  void Render();
  void UpdateRivers();
  void ShrinkRivers();
  
  std::vector<vcg::Point2f> location; // cityes etc
  bool LoadLocations(char* filename);
  void ComputeShade();
  
  vcg::Point3f GetClosestVertP(vcg::Point3f p) const; // returns height of the closest vert
  float GetZ(vcg::Point3f p) const; // returns height of a given x,y point on map
  vcg::Point3f GetN() const; // returns normal of last point accessed with GetZ
};


extern Map map; // cheap singleton
